	program test
    
    use latexTableMakerClass !declare the class
    
    implicit none
    
    type(latexTableMaker)  :: Table !create table object
    type(latexTableColumn) :: tableColumns(6) !create column wrappers with data
     
    real*8                  :: real8Data(5) = [0.3,0.2,1.0,0.4,0.5]
    real*4                  :: real4Data(5) = [0.2,0.1,3.0,1.443,0.54]
    integer                 :: intData(5)  = [2,3,1,10,200]
    character(LEN=5)        :: headers(5)  = ["row1","row2","row3","row4 ","row5"]
    character(LEN=23)       :: title       = "My first table"
    character(LEN=10)       :: label       = "myTable"
 
    integer :: ios
 
!   upload data to column wrappers
      
    call constructLatexTableColumn(tableColumn = tableColumns(1),&
                                     title        = "Characters",&
                                     columnData   = headers,&
                                     columnFormat = "(A)") 
      
    call constructLatexTableColumn(tableColumn  = tableColumns(2),&
                                     title        = "Integers",&
                                     columnData   = intData,&
                                     columnFormat = "(i6)")
      
    call constructLatexTableColumn(tableColumn  = tableColumns(3),&
                                     title        = "Reals",&
                                     columnData   = real4Data,&
                                     columnFormat = "(f12.5)")
      
    call constructLatexTableColumn(tableColumn  = tableColumns(4),&
                                     title        = "Doubles",&
                                     columnData   = real8Data,&
                                     columnFormat = "(f12.5)")
            
    call constructLatexTableColumn(tableColumn  = tableColumns(5),&
                                     title        = "Doubles",&
                                     columnData   = real8Data,&
                                     columnFormat = "(f12.5)")
      
    call constructLatexTableColumn(tableColumn  = tableColumns(6),&
                                     title        = "Doubles",&
                                     columnData   = real8Data,&
                                     columnFormat = "(f12.5)")

!   add layered column headers 
    call Table % addColumnHeaderLayer(headers=(/'Column', 'Marged Columns' /), span=(/1,4/), level=2) 
    call Table % addColumnHeaderLayer(headers=(/'', 'Block 1', 'Block 2' /), span=(/1,2,2/), level=1) 
     
!   add row block labels:  
    call Table % addRowBlockHeader(header='Block header 1',row=1)  
    call Table % addRowBlockHeader(header='Block header 1',row=3)  
 
!   write sample table to as tex file and compile to a pdf using pdflatex
    call Table % writeTableAsLatex(tableColumnsArray = tableColumns,&
                                      title           = title, &
                                      label           = label )    
end program test